clear; clf;

%----- USER DATA -----
[DAFx_in, SR] = wavread('la.wav'); % sound file
warping_coef  = 2.;
n1            = 512;               % analysis hop size
n2            = n1;                % synthesis hop size
WindowLength  = 2048;              % window length
w1            = hanningz(WindowLength);    % analysis window
w2            = w1;                % syhnthesis window
order         = 50;                % cut quefrency

%----- initialisations -----
WindowLength2 = WindowLength / 2;
L             = length(DAFx_in);
DAFx_in       = [zeros(WindowLength, 1); DAFx_in; ...
   zeros(WindowLength-mod(L,n1),1)] / max(abs(DAFx_in));
DAFx_out      = zeros(L,1);
x0            = floor(min((1+(0:WindowLength2)/warping_coef), 1+WindowLength2)); 
               % apply the warping
x             = [x0, x0(WindowLength2:-1:2)];% symmetric extension

tic
%UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
pin  = 0;
pout = 0;
pend = L - WindowLength;

while pin<pend
   grain = DAFx_in(pin+1:pin+WindowLength).* w1;
%===========================================
   f     = fft(grain)/WindowLength2;
   flog  = log(0.00001+abs(f));
   cep   = ifft(flog);
   cep_coupe   = [cep(1)/2; cep(2:order); zeros(WindowLength-order,1)];
   % flogcoupe 1/2 are the spectral shapes before/after formant move
   flog_coupe1 = 2*real(fft(cep_coupe));
   flog_coupe2 = flog_coupe1(x);
   corr  = exp(flog_coupe2-flog_coupe1);
   grain = (real(ifft(f.*corr))).*w2;
% ===========================================
   DAFx_out(pout+1:pout+WindowLength) = DAFx_out(pout+1:pout+WindowLength) + grain;
   pin   = pin + n1;
   pout  = pout + n2;
end
%UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU
toc

%----- listening and saving the output -----
soundsc(DAFx_out, SR);
DAFx_out_norm = .99* DAFx_out/max(abs(DAFx_out)); % scale for wav output
wavwrite(DAFx_out_norm, SR, 'la_fomove.wav');
