% M-file 9.5
% specenvceps.m
% 
% Spectral envelope with cepstrum

[y,Fs] = wavread('la');
offset = 1000;

% N1: cut quefrency
WLen=2048; w=hanningz(WLen);
buf=y(offset:offset+WLen-1).*w;
f=fft(buf)/(WLen/2);
flog=20*log10(0.00001+abs(f));
freq = (0:2:WLen-1)/WLen*Fs;          % frequency of each bin (in Hertz)

%----- plotting the Magnitude -----
clf
subplot(2,1,1); 
plot(freq, flog(1:WLen/2));
ylabel('X(f)/dB');
xlabel('f/Hz \rightarrow'); 
axis([0 8000 -110 0]);
title('Short-time spectrum and spectral shape');

N1=input('cut value for cepstrum (e.g. 150): ');
cep=ifft(flog);
cep_cut=[cep(1);2*cep(2:N1);cep(N1+1);zeros(WLen-N1-1,1)];
flog_cut=real(fft(cep_cut));

%----- plotting the spectral shape -----
subplot(2,1,2); 
plot(freq, flog_cut(1:WLen/2));
ylabel('Shape(f)/dB');
xlabel('f/Hz \rightarrow'); 
axis([0 8000 -110 0]);

