% M-file 9.1
% specenvcv.m
%
% Spectral envelope with channel vocoder

y = wavread('la');
offset = 1000;

WLen=2048; w=hanningz(WLen);
buf=y(offset:offset+WLen-1).*w;
f=fft(buf)/(WLen/2);
freq=(0:1:WLen-1)/WLen*44100;
flog=20*log10(0.00001+abs(f));
% Frequency window
nob=input('number of bins (must be even, e.g. 20) = ');
w1=hanningz(nob);w1=w1./sum(w1);
f_channel=[zeros((WLen-nob)/2,1);w1;zeros((WLen-nob)/2,1)];
% FFT of frequency window
fft_channel=fft(fftshift(f_channel));
f2=f.*conj(f); % Squared FFT values
% Circ. Convolution by FFT-Multiplication-IFFT
energy=real(ifft(fft(f2).*fft_channel));
flog_rms=10*log10(abs(energy));
%10 indicates a combination with sqrt operation
clf
subplot(2,1,1);
plot(freq,flog,freq,flog_rms);
ylabel('X(f)/dB');
xlabel('f/Hz \rightarrow');
axis([0 8000 -110 0]);
title('Short-time spectrum and spectral envelope');
